"""
Yum plugin for ULN access.
This plugin provides ULN license, notification, entitlement to yum client.
"""
import os, sys, urllib2, re, time, datetime
sys.path.append("/usr/share/rhn/")
from up2date_client import config
from up2date_client import rhnChannel
try:
    import xml.etree.ElementTree as ET
except:
    import cElementTree as ET
requires_api_version = '2.5'

def bypass_m2crypto_ssl_connection_check(*args, **kw):
    """This needs to return True, it's used to bypass a check in 
    M2Crypto.SSL.Connection
    """
    return True

def paraseMsgXml(rootElem):
    n = {}
    if rootElem.tag == 'notification':
        for child in rootElem:
            n[child.tag] = child.text
    return n

def init_hook(conduit):
    try:
        svrChannels = rhnChannel.getChannelDetails()
    except up2dateErrors.NoChannelsError:
        conduit.error(0, _("This system is not subscribed to any channels.") +
            "\n" + CHANNELS_DISABLED)
        return
    up2date_cfg = config.initUp2dateConfig()
    base_url = up2date_cfg['serverURL'].split("/")[2]
    # check commands and options which don't need network communication
    prog_name = os.path.basename(sys.argv[0])
    if prog_name == 'yum':
        cmd_args = sys.argv[1:]
        uln_enabled = True
        if ('--help' in cmd_args or '--version' in cmd_args or cmd_args == [] or '-C' in cmd_args or '--cacheonly' in cmd_args):
            uln_enabled = False
            return
    if uln_enabled:
        for channel in svrChannels:
            if channel['version']:
                try:
                    print urllib2.urlopen("http://"+base_url+"/license/%s" %channel['label']).read()
                except:
                    #print "No license available for channel", channel['label']
                    pass
